//here executing dataline.sci,Ybus.sci,databus.sci,intialization.sci and Lindex.sci
//to find the load flow analysis in 6 bus system and Lindex using newton raphson method
//and bar graph representation
clear;
clc;
exec('dataline.sci');
exec('Ybus.sci');
absY = abs(Y);
thetaY = atan(imag(Y),real(Y));
exec('databus.sci');
nb = max(Bdata(:, 1)); 
Psp = Bdata(:, 2); 
Qsp = Bdata(:, 3); 
vsp = Bdata(:, 4);   
rem = Bdata(:, 5); 
v = vsp';
itr=1;
k=sqrt(-1);
ang = zeros(1, nb);  
mismatch = ones(2*nb-2-npv, 1);

// Iterative solution
while max(abs(mismatch)) > 0.001
    exec('Initialization.sci');
    ang ;
    mag = abs (v ) ;
    for i =2:nb
        for j =1:nb
            P ( i ) = P( i ) + mag ( i )* mag ( j ) * absY (i , j ) * cos (thetaY (i , j ) - ang ( i ) + ang ( j ) ) ;
            if rem ( i ) ~=3
                Q ( i ) = Q( i ) + mag ( i ) * mag ( j ) * absY (i , j ) *sin ( thetaY (i , j ) - ang ( i ) + ang ( j ) );
end
end
end
Q = -1*Q ;
del_P = Psp-P ;
del_Q = Qsp-Q ;
for i =2:nb
    for j =2:nb
        if j ~= i
            J1 (i -1 ,j -1) = - mag ( i ) * mag ( j )* absY (i , j )* sin( thetaY (i , j ) - ang ( i ) + ang ( j )) ;
            J2 (i -1 ,j -1) = mag ( i ) * absY (i , j ) * cos ( thetaY (i , j ) - ang ( i ) + ang ( j )) ;
            J3 (i -1 ,j -1) = - mag ( i ) * mag ( j )* absY (i , j )* cos( thetaY (i , j ) - ang (i ) + ang ( j ) );
            J4 (i -1 ,j -1) = - mag ( i ) * absY (i , j ) * sin ( thetaY(i , j ) - ang ( i ) + ang (j ) ) ;
end
end
end
for i =2:nb
    for j =1:nb
        if j ~= i
            J1 (i -1 ,i -1) = J1 (i -1 ,i -1) + mag ( i ) * mag ( j) *absY (i ,j ) * sin ( thetaY (i , j ) - ang ( i ) + ang (j ) ) ;
            J2 (i -1 ,i -1) = J2 (i -1 ,i -1) + mag ( j ) * absY (i , j )* cos ( thetaY (i , j ) - ang ( i ) + ang ( j ) ) ;
            J3 (i -1 ,i -1) = J3 (i -1 ,i -1) + mag ( i ) * mag ( j) *absY (i ,j ) * cos ( thetaY (i , j ) - ang ( i ) + ang (j ) ) ;
            J4 (i -1 ,i -1) = J4 (i -1 ,i -1) + mag ( j ) * absY (i , j )* sin ( thetaY (i , j ) - ang ( i ) + ang ( j ) ) ;
end
end
    J2 (i -1 ,i -1) =2* mag ( i ) * absY (i , i ) * cos ( thetaY (i , i )) +J2 (i -1 ,i -1) ;
    J4 (i -1 ,i -1) = -2* mag ( i ) * absY (i , i ) * sin ( thetaY (i , i) )- J4 (i -1 ,i -1) ;
end
J =[ J1 J2; J3 J4]
lenJ = length( J1(:,1)) ;
i =2;
j =1;
while j <= lenJ
    if rem ( i ) ==2
        j = j +1;
    else
        J (: , length ( J1(:,1)) + j) =[];
        lenJ = lenJ -1;
end
    i = i +1;
end
lenJ = length ( J1(:,1)) ;
i =1;
j =2;
while i <= lenJ
    if rem ( j ) ==2
        i = i +1;
    else
        J ( length ( J1(:,1)) +i ,:) =[];
        lenJ = lenJ -1;
        Q ( i +1) =[]
        del_Q ( i +1 ,:) =[]
end
j=j+1;
end
P (1 ,:) =[]
Q (1 ,:) =[]
del_P (1 ,:) =[];
del_Q (1 ,:) =[];
mismatch =[ del_P ; del_Q ];
del =J\mismatch ;
del_del = del (1:nb -1) ;
del_v = del ( nb : length ( del ) ) ;
ang = ang (2: nb ) + del_del';
j =1;
for i =2: nb
    if rem ( i ) ==2
        v ( i ) =v ( i ) + del_v (j ) ;
        j = j +1;
end
end
ang =[0 ang ];
itr= itr+1;
end

// Display the voltage
v =[mag.*exp(k*ang)]';

// Output Lindex and related calculations
exec('Lindex.sci');
bar(L_index)
xlabel('Bus Number')
ylabel('Lindex')
title('Lindex of buses in IEEE 6 bus test system')
